CPIVolatilitySurface Class Referenceabstract

zero inflation (i.e. CPI/RPI/HICP/etc.) volatility structures More...

`#include <ql/termstructures/volatility/inflation/cpivolatilitystructure.hpp>`

Inheritance diagram for CPIVolatilitySurface:
[legend]

## Public Member Functions

| CPIVolatilitySurface (Natural settlementDays, const Calendar &, BusinessDayConvention bdc, const DayCounter &dc, const Period &observationLag, Frequency frequency, bool indexIsInterpolated)
Volatility
Volatility | volatility (const Date &maturityDate, Rate strike, const Period &obsLag=Period(-1, Days), bool extrapolate=false) const
| Returns the volatility for a given maturity date and strike rate. More...
Volatility | volatility (const Period &optionTenor, Rate strike, const Period &obsLag=Period(-1, Days), bool extrapolate=false) const
| returns the volatility for a given option tenor and strike rate
virtual Volatility | totalVariance (const Date &exerciseDate, Rate strike, const Period &obsLag=Period(-1, Days), bool extrapolate=false) const
virtual Volatility | totalVariance (const Period &optionTenor, Rate strike, const Period &obsLag=Period(-1, Days), bool extrapolate=false) const
Inspectors
virtual Period | observationLag () const
virtual Frequency | frequency () const
virtual bool | indexIsInterpolated () const
virtual Date | baseDate () const
virtual Time | timeFromBase (const Date &date, const Period &obsLag=Period(-1, Days)) const
| base date will be in the past because of observation lag
virtual Volatility | baseLevel () const
Limits
virtual Real | minStrike () const =0
| the minimum strike for which the term structure can return vols
virtual Real | maxStrike () const =0
| the maximum strike for which the term structure can return vols
Public Member Functions inherited from VolatilityTermStructure
virtual BusinessDayConvention | businessDayConvention () const
| the business day convention used in tenor to date conversion
Date | optionDateFromTenor (const Period &) const
| period/date conversion
| VolatilityTermStructure (BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| VolatilityTermStructure (const Date &referenceDate, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| VolatilityTermStructure (Natural settlementDays, const Calendar &cal, BusinessDayConvention bdc, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
Public Member Functions inherited from TermStructure
| TermStructure (const DayCounter &dc=DayCounter())
| default constructor More...
| TermStructure (const Date &referenceDate, const Calendar &calendar=Calendar(), const DayCounter &dc=DayCounter())
| initialize with a fixed reference date
| TermStructure (Natural settlementDays, const Calendar &, const DayCounter &dc=DayCounter())
| calculate the reference date based on the global evaluation date
virtual DayCounter | dayCounter () const
| the day counter used for date/time conversion
Time | timeFromReference (const Date &date) const
| date/time conversion
virtual Date | maxDate () const =0
| the latest date for which the curve can return values
virtual Time | maxTime () const
| the latest time for which the curve can return values
virtual const Date & | referenceDate () const
| the date at which discount = 1.0 and/or variance = 0.0
virtual Calendar | calendar () const
| the calendar used for reference and/or option date calculation
virtual Natural | settlementDays () const
| the settlementDays used for reference date calculation
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const boost::shared_ptr< Observable > &)
void | registerWithObservables (const boost::shared_ptr< Observer > &)
Size | unregisterWith (const boost::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## Protected Member Functions

virtual void | checkRange (const Date &, Rate strike, bool extrapolate) const
virtual void | checkRange (Time, Rate strike, bool extrapolate) const
virtual Volatility | volatilityImpl (Time length, Rate strike) const =0
Protected Member Functions inherited from VolatilityTermStructure
void | checkStrike (Rate strike, bool extrapolate) const
| strike-range check
Protected Member Functions inherited from TermStructure
void | checkRange (const Date &d, bool extrapolate) const
| date-range check
void | checkRange (Time t, bool extrapolate) const
| time-range check

## Protected Attributes

Volatility | baseLevel_
Period | observationLag_
Frequency | frequency_
bool | indexIsInterpolated_
Protected Attributes inherited from TermStructure
bool | moving_
bool | updated_
Calendar | calendar_

## Additional Inherited Members

Public Types inherited from Observer
typedef std::set< boost::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Detailed Description

zero inflation (i.e. CPI/RPI/HICP/etc.) volatility structures

Abstract interface. CPI volatility is always with respect to some base date. Also deal with lagged observations of an index with a (usually different) availability lag.

## Constructor & Destructor Documentation

## CPIVolatilitySurface()

CPIVolatilitySurface | ( | Natural | settlementDays,
|  | const Calendar & | ,
|  | BusinessDayConvention | bdc,
|  | const DayCounter & | dc,
|  | const Period & | observationLag,
|  | Frequency | frequency,
|  | bool | indexIsInterpolated
| ) |  |

calculates the reference date based on the global evaluation date.

## Member Function Documentation

## volatility()

Volatility volatility | ( | const Date & | maturityDate,
|  | Rate | strike,
|  | const Period & | obsLag = `Period(-1, Days)`,
|  | bool | extrapolate = `false`
| ) |  | const

Returns the volatility for a given maturity date and strike rate.

by default, inflation is observed with the lag of the term structure.

Because inflation is highly linked to dates (for interpolation, periods, etc) time-based overload of the methods are not provided.

## totalVariance() [1/2]

virtual Volatility totalVariance | ( | const Date & | exerciseDate,
|  | Rate | strike,
|  | const Period & | obsLag = `Period(-1, Days)`,
|  | bool | extrapolate = `false`
| ) |  | const

virtual

Returns the total integrated variance for a given exercise date and strike rate.
Total integrated variance is useful because it scales out t for the optionlet pricing formulae. Note that it is called "total" because the surface does not know whether it represents Black, Bachelier or Displaced Diffusion variance. These are virtual so alternate connections between const vol and total var are possible.

## totalVariance() [2/2]

virtual Volatility totalVariance | ( | const Period & | optionTenor,
|  | Rate | strike,
|  | const Period & | obsLag = `Period(-1, Days)`,
|  | bool | extrapolate = `false`
| ) |  | const

virtual

returns the total integrated variance for a given option tenor and strike rate.

## observationLag()

virtual Period observationLag | ( |  | ) | const

virtual

The term structure observes with a lag that is usually different from the availability lag of the index. An inflation rate is given, by default, for the maturity requested assuming this lag.

## volatilityImpl()

virtual Volatility volatilityImpl | ( | Time | length,
|  | Rate | strike
| ) |  | const

protected pure virtual

Implements the actual volatility surface calculation in derived classes e.g. bilinear interpolation. N.B. does not derive the surface.